package com.hz.pm.api.common.statemachine.util;

import com.hz.pm.api.common.statemachine.builder.*;
import com.hz.pm.api.common.statemachine.contant.RegionContant;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.Map;

/**
 * 项目申报状态机
 *
 * @author CMM
 * @since 2023/02/07 15:56
 */
@Slf4j
@Component
@RequiredArgsConstructor
public class MachineBuilderFounder {

    private static final Map<String, ProjectDeclareStateMachineBuilder> MACHINE_BUILDER_MAP = new HashMap<>(16);

    public static ProjectDeclareStateMachineBuilder getByRegion(String regionCode) {
        return MACHINE_BUILDER_MAP.get(regionCode);
    }

    private final ProjectDeclareStateMachineSBJBuilder projectDeclareStateMachineSBJBuilder;
    private final ProjectDeclareStateMachineLDBuilder projectDeclareStateMachineLDBuilder;
    private final ProjectDeclareStateMachineQTBuilder projectDeclareStateMachineQTBuilder;
    private final ProjectDeclareStateMachineJYBuilder projectDeclareStateMachineJYBuilder;
    private final ProjectDeclareStateMachineSCBuilder projectDeclareStateMachineSCBuilder;
    private final ProjectDeclareStateMachineSYBuilder projectDeclareStateMachineSYBuilder;
    private final ProjectDeclareStateMachineYHBuilder projectDeclareStateMachineYHBuilder;
    private final ProjectDeclareStateMachineQYBuilder projectDeclareStateMachineQYBuilder;
    private final ProjectDeclareStateMachineJNBuilder projectDeclareStateMachineJNBuilder;
    private final ProjectDeclareStateMachineLQBuilder projectDeclareStateMachineLQBuilder;
    private final ProjectDeclareStateMachineKFQBuilder projectDeclareStateMachineKFQBuilder;

    @PostConstruct
    public void machineBuilderFounder(){
        MACHINE_BUILDER_MAP.put(RegionContant.LS_SBJ_CODE, projectDeclareStateMachineSBJBuilder);
        MACHINE_BUILDER_MAP.put(RegionContant.LS_LD_CODE, projectDeclareStateMachineLDBuilder);
        MACHINE_BUILDER_MAP.put(RegionContant.LS_QT_CODE, projectDeclareStateMachineQTBuilder);
        MACHINE_BUILDER_MAP.put(RegionContant.LS_JY_CODE, projectDeclareStateMachineJYBuilder);
        MACHINE_BUILDER_MAP.put(RegionContant.LS_SC_CODE, projectDeclareStateMachineSCBuilder);
        MACHINE_BUILDER_MAP.put(RegionContant.LS_SY_CODE, projectDeclareStateMachineSYBuilder);
        MACHINE_BUILDER_MAP.put(RegionContant.LS_YH_CODE, projectDeclareStateMachineYHBuilder);
        MACHINE_BUILDER_MAP.put(RegionContant.LS_QY_CODE, projectDeclareStateMachineQYBuilder);
        MACHINE_BUILDER_MAP.put(RegionContant.LS_JN_CODE, projectDeclareStateMachineJNBuilder);
        MACHINE_BUILDER_MAP.put(RegionContant.LS_LQ_CODE, projectDeclareStateMachineLQBuilder);
        MACHINE_BUILDER_MAP.put(RegionContant.LS_KFQ_CODE, projectDeclareStateMachineKFQBuilder);
    }

}
